import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class Minion here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Minion extends Actor
{
    /**
     * Act - do whatever the Minion wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    
    private int frame = 1;
    private boolean walking = true;  
    
    private int speed = 1;
    
    
    public void walk(GreenfootImage walk1f,GreenfootImage walk2f,GreenfootImage standf )
    {
        int targetX = 200; // getNearestBase().getX();
        int targetY = 50; //getNearestBase().getY();
        int xChange = speed;
        int yChange = speed;
        
        if (targetX - getX() < 0)
        {
          xChange = speed * -1;   
        } else {
          xChange = speed; 
        }
        
        if (targetY - getY() < 0) {
          yChange = speed * -1;  
        } else {
          yChange = speed;  
        }
        
        if (walking == true)
        {
            setLocation(getX(), getY() - speed);
            animateWalkForward(walk1f,walk2f,standf);
            
        }
        if (! enemyNear() ) {  
               walking = false;
               setImage(standf); 
               attack();
        } /* else if(enemyNear() == "minion") {
               walking = false;
               setImage(standf);
               attackMinion();
        } */else {
            walking = true;
        }
        MyWorld theWorld = (MyWorld) getWorld();
        Debug debugBox = theWorld.getDebugBox();
        //debugBox.postMessage("enemyNear: " + enemyNear());
        if ( isAtEdge() )
        {
            getWorld().removeObject(this);
        }
    }
    
    private boolean enemyNear() {
         /*if (getObjectsInRange(50, MinionTypeB.class).isEmpty())
         {
             return "base";
         } else if(getObjectsInRange(50, Player2Base.class).isEmpty()) {
             return "minion"; 
         } else {
             return "none";
         }*/
         return getObjectsInRange(50, Player2Base.class).isEmpty();
         
    }
    
   
    
    
    public void animateWalkForward(GreenfootImage walk1f,GreenfootImage walk2f,GreenfootImage standf)
    {
        if(frame == 1)
        {
            setImage(walk1f);
        }
        else if(frame == 20)
        {
            setImage(walk2f);
        }
        else if(frame == 40)
        {
            setImage(walk1f);
        }
        else if(frame == 60)
        {
            setImage(walk2f);
        }
        else if(frame == 80)
        {
            setImage(walk1f);
            frame = 1;
            return;
        }
        //Greenfoot.delay(10);
        frame++;
    }
    private int attackTimer = 0;
    private BattleEffect  magicAttack = new BattleEffect();
    private boolean attackOn = false;
    public void attack()
    {
        
        if( attackTimer < 0 && attackOn == false) 
        {
            getWorld().addObject(magicAttack, getX(), getY() -50);
            attackTimer = 100;
            attackOn = true;
            
            Player2Base enemyBase = getNearestBase();
            if( enemyBase != null )
            {
                enemyBase.damageHealth(25);
            }
            /*
            MinionTypeB enemyMinion = getNearestEnemy();
            if( enemyBase != null )
            {
                enemyBase.damageHealth(25);
            }*/
        
        } else if ( attackTimer < 50 && attackOn == true) 
        {
            getWorld().removeObject(magicAttack);
            attackTimer--;
            attackOn = false;
        } else {
            attackTimer--;
        }
        // b #List EnemyBases = (Player2Base) getOneObjectAtOffset(50, getY(), Player2Base.class);
        
        
    } 
    public void attackMinion()
    {
        
        if( attackTimer < 0 && attackOn == false) 
        {
            getWorld().addObject(magicAttack, getX(), getY() -50);
            attackTimer = 100;
            attackOn = true;
            
            
            MinionTypeB enemyMinion = getNearestEnemy();
            if( enemyMinion != null )
            {
                enemyMinion.damageHealth(11);
            }
        
        } else if ( attackTimer < 50 && attackOn == true) 
        {
            getWorld().removeObject(magicAttack);
            attackTimer--;
            attackOn = false;
        } else {
            attackTimer--;
        }
        // b #List EnemyBases = (Player2Base) getOneObjectAtOffset(50, getY(), Player2Base.class);
        
        
    } 
    
    public double getDistance(Actor actor) {
        return Math.hypot(actor.getX() - getX(), actor.getY() - getY());
    }
 
    public Player2Base getNearestBase() {
        List<Player2Base> nearBases = getObjectsInRange(50, Player2Base.class);//here you can use the radius you want and maybe another class;
        Player2Base nearestBase = null;
        double nearestDistance = 100;
        double distance;
        for (int i = 0; i < nearBases.size(); i++) {
            distance = getDistance(nearBases.get(i));
            if (distance < nearestDistance) {
                nearestBase = nearBases.get(i);
                nearestDistance = distance;
            }
        }
        return nearestBase;
    }
    public MinionTypeB getNearestEnemy() {
        List<MinionTypeB> nearBases = getObjectsInRange(50, MinionTypeB.class);//here you can use the radius you want and maybe another class;
        MinionTypeB nearestBase = null;
        double nearestDistance = 100;
        double distance;
        for (int i = 0; i < nearBases.size(); i++) {
            distance = getDistance(nearBases.get(i));
            if (distance < nearestDistance) {
                nearestBase = nearBases.get(i);
                nearestDistance = distance;
            }
        }
        return nearestBase;
    }
    
}
