import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MyWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MyWorld extends World
{

    /**
     * Constructor for objects of class MyWorld.
     * 
     */
    public MyWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(400, 600, 1); 
        prepare();
    }

    /**
     * Prepare the world for the start of the program.
     * That is: create the initial objects and add them to the world.
     */
    private void prepare()
    {
        Player1Base player1base = new Player1Base();
        addObject(player1base,69,466);
        Player1Base player1base2 = new Player1Base();
        addObject(player1base2,326,466);
        Player2Base player2base = new Player2Base();
        addObject(player2base,78,150);
        Player2Base player2base2 = new Player2Base();
        addObject(player2base2,330,153);
        generateCards(1);
        generateCards(2);
        generateCards(3);
        generateCards(4);
        addObject(debugBox, getWidth()/2, 50);
    }
    
    
    public void generateCards(int position)
    {
        
            
                int randomCard = Greenfoot.getRandomNumber(12);
                Card chosenCard;
                if( randomCard > 9) {
                    chosenCard = new Card1(position); 
                } else if(randomCard > 6) {
                    chosenCard = new Card2(position);
                }  else if(randomCard > 3) {
                    chosenCard = new Card3(position);
                } else {
                    chosenCard = new Card4(position);
                }
                addObject(chosenCard, getWidth()/5 * position, getHeight()-60);
            
            
        
    }
    
    private Debug debugBox = new Debug();
    public Debug getDebugBox()
    {
        return debugBox;
    }
}
